/********************************************************************************
*                  QLOGIC LINUX SOFTWARE
*
* QLogic ISP2x00 device driver for Linux 2.2.x (redhat 6.X).
*
* COPYRIGHT (C) 2000 QLOGIC CORPORATION
*
* This program is free software; you can redistribute it and/or modify
* it under the terms of the Qlogic's Linux Software License. See below.
*
* This program is WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
*
* Redistribution and use in source and binary forms, with or without
* modification, are permitted provided that the following conditions
* are met:
*
* 1. Redistribution's or source code must retain the above copyright
*    notice, this list of conditions, and the following disclaimer,
*    without modification, immediately at the beginning of the file.
* 2. The name of the author may not be used to endorse or promote products
*    derived from this software without specific prior written permission.
*
********************************************************************************/

/*****************************************************************************************
                       QLOGIC CORPORATION SOFTWARE
                      "GNU" GENERAL PUBLIC LICENSE
             TERMS AND CONDITIONS FOR COPYING, DISTRIBUTION
                            AND MODIFICATION

This GNU General Public License ("License") applies solely to QLogic Linux
Software ("Software") and may be distributed under the terms of this License.

1. You may copy and distribute verbatim copies of the Software's source code as
you receive it, in any medium, provided that you conspicuously and appropriately
publish on each copy an appropriate copyright notice and disclaimer of warranty;
keep intact all the notices that refer to this License and to the absence of any
warranty; and give any other recipients of the Software a copy of this License along
with the Software.

You may charge a fee for the physical act of transferring a copy, and you may at your
option offer warranty protection in exchange for a fee.

2. You may modify your copy or copies of the Software or any portion of it, thus forming
a work based on the Software, and copy and distribute such modifications or work under
the terms of Section 1 above, provided that you also meet all of these conditions:

* a) You must cause the modified files to carry prominent notices stating that you
changed the files and the date of any change.

* b) You must cause any work that you distribute or publish that in whole or in part
contains or is derived from the Software or any part thereof, to be licensed as a
whole at no charge to all third parties under the terms of this License.

* c) If the modified Software normally reads commands interactively when run, you
must cause it, when started running for such interactive use in the most ordinary way,
to print or display an announcement including an appropriate copyright notice and a
notice that there is no warranty (or else, saying that you provide a warranty) and that
users may redistribute the Software under these conditions, and telling the user how to
view a copy of this License. (Exception:if the Software itself is interactive but does
not normally print such an announcement, your work based on the Software is not required
to print an announcement.)

These requirements apply to the modified work as a whole. If identifiable sections of
that work are not derived from the Software, and can be reasonably considered independent
and separate works in themselves, then this License, and its terms, do not apply to those
sections when you distribute them as separate works. But when you distribute the same
sections as part of a whole which is a work based on the Software, the distribution of the
whole must be on the terms of this License, whose permissions for other licensees extend
to the entire whole, and thus to each and every part regardless of who wrote it.

3. You may copy and distribute the Software (or a work based on it, under Section 2) in
object code or executable form under the terms of Sections 1 and 2 above provided that
you also do one of the following:

* a) Accompany it with the complete corresponding machine-readable source code, which must
be distributed under the terms of Sections 1 and 2 above on a medium customarily used for
software interchange; or,

* b) Accompany it with a written offer, valid for at least three years, to give any third
party, for a charge no more than your cost of physically performing source distribution,
a complete machine-readable copy of the corresponding source code, to be distributed under
the terms of Sections 1 and 2 above on a medium customarily used for software interchange;
or,

* c) Accompany it with the information you received as to the offer to distribute
corresponding source code. (This alternative is allowed only for noncommercial distribution
and only if you received the Software in object code or executable form with such an offer,
in accord with Subsection b above.)

The source code for a work means the preferred form of the work for making modifications
to it. For an executable work, complete source code means all the source code for all
modules it contains, plus any associated interface definition files, plus the scripts used
to control compilation and installation of the executable.

If distribution of executable or object code is made by offering access to copy from a
designated place, then offering equivalent access to copy the source code from the same
place counts as distribution of the source code, even though third parties are not
compelled to copy the source along with the object code.

4. You may not copy, modify, sublicense, or distribute the Software except as expressly
provided under this License. Any attempt otherwise to copy, modify, sublicense or
distribute the Software is void, and will automatically terminate your rights under this
License. However, parties who have received copies, or rights, from you under this License
will not have their licenses terminated so long as such parties remain in full compliance.

5. This license grants you world wide, royalty free non-exclusive rights to modify or
distribute the Software or its derivative works. These actions are prohibited by law
if you do not accept this License. Therefore, by modifying or distributing the Software
(or any work based on the Software), you indicate your acceptance of this License to do
so, and all its terms and conditions for copying, distributing or modifying the Software
or works based on it.

6. Each time you redistribute the Software (or any work based on the Software), the
recipient automatically receives a license from the original licensor to copy, distribute
or modify the Software subject to these terms and conditions. You may not impose any
further restrictions on the recipients' exercise of the rights granted herein. You are
not responsible for enforcing compliance by third parties to this License.

7. If, as a consequence of a court judgment or allegation of patent infringement or for
any other reason (not limited to patent issues), conditions are imposed on you
(whether by court order, agreement or otherwise) that contradict the conditions of this
License, they do not excuse you from the conditions of this License. If you cannot
distribute so as to satisfy simultaneously your obligations under this License
and any other pertinent obligations, then as a consequence you may not distribute the
Software at all.

If any portion of this section is held invalid or unenforceable under any particular
circumstance, the balance of the section is intended to apply and the section as a whole
is intended to apply in other circumstances.
NO WARRANTY

11. THE SOFTWARE IS PROVIDEDWITHOUT A WARRANTY OF ANY KIND. THERE IS NO
WARRANTY FOR THE SOFTWARE, TO THE EXTENT PERMITTED BY APPLICABLE LAW.
EXCEPT WHEN OTHERWISE STATED IN WRITING THE COPYRIGHT HOLDERS AND/OR
OTHER PARTIES PROVIDE THE SOFTWARE "AS IS" WITHOUT WARRANTY OF ANY KIND,
EITHER EXPRESSED OR IMPLIED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE. THE
ENTIRE RISK AS TO THE QUALITY AND PERFORMANCE OF THE SOFTWARE IS WITH YOU.
SHOULD THE SOFTWARE PROVE DEFECTIVE, YOU ASSUME THE COST OF ALL
NECESSARY SERVICING, REPAIR OR CORRECTION.

12. IN NO EVENT UNLESS REQUIRED BY APPLICABLE LAW OR AGREED TO IN WRITING
WILL ANY COPYRIGHT HOLDER, OR ANY OTHER PARTY WHO MAY MODIFY AND/OR
REDISTRIBUTE THE SOFTWARE AS PERMITTED ABOVE, BE LIABLE TO YOU FOR
DAMAGES, INCLUDING ANY GENERAL, SPECIAL, INCIDENTAL OR CONSEQUENTIAL
DAMAGES ARISING OUT OF THE USE OR INABILITY TO USE THE SOFTWARE (INCLUDING
BUT NOT LIMITED TO LOSS OF DATA OR DATA BEING RENDERED INACCURATE OR
LOSSES SUSTAINED BY YOU OR THIRD PARTIES OR A FAILURE OF THE SOFTWARE TO
OPERATE WITH ANY OTHER SOFTWARES), EVEN IF SUCH HOLDER OR OTHER PARTY HAS
BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.
END OF TERMS AND CONDITIONS

******************************************************************************/
/*
 * vendor specific op codes.
*/

#define	UCSCSI_DCMD			0x20 /* DAC960 direct command */
#define DAC_CDB_LEN			12
#define DAC_SENSE_LEN			64

#define DACMD_WRITE_CONF_ONDISK		0x4B
#define	DACMD_WRITE_CONFIG		0x06
#define	DACMD_WRITE_CONF2		0x3C
#define	DACMD_WRITE_CONFLABEL		0x49 /* Write configuration label */
#define	DACMD_WRITE_CONFIG_V3x		0x4F
#define	DACMD_ADD_CONFIG_V2x		0x18
#define	DACMD_ADD_CONFIG_V3x		0x4C
#define	DACMD_STORE_IMAGE		0x21
#define	DACMD_ADD_CAPACITY		0x2A /* add physical drives to existing array */
#define	DACMD_WRITE_IOPORT		0x3A /* write port B */
#define	DACMD_S2S_WRITEFULLCONF		0x60 /* write full configuration */
#define	DACMD_S2S_ADDFULLCONF		0x62 /* add   full configuration */
#define	DACMD_S2S_WRITELUNMAP_OLD	0x58 /* write LUN map information */
#define DACMD_S2S_WRITELUNMAP		0xD2 /* Write LUN MAP Information */
#define	DACMD_S2S_WRITE_IOPORT		0x66 /* write expanded IO port */
#define	DACMD_WRITE_V3x			0x34 /* write data from plain memory */
#define	DACMD_S2S_WRITESIG		0x4D /* write signature information */

    /*
    * qla2100_set_scsi_direction
    *      This routine will set the proper direction for vendor specific
    *      commands. 
    *
    *      Note: Vendors should modify this routine to set the proper 
    *      direction of the transfer if they used vendor specific commands.
    *
    * Input:
    *      ha = adapter block pointer.
    *      sp = SCSI Request Block structure pointer.
    *
    * Returns:
    *      0 = success, was able to issue command.
    */
    STATIC void
    qla2100_set_vend_direction(scsi_qla_host_t *ha, 
 			Scsi_Cmnd       *cmd, cmd_entry_t     *pkt) {
            
			if( cmd->data_cmnd[0] == UCSCSI_DCMD )
			{
			    pkt->control_flags = 0;
			    switch( cmd->data_cmnd[2] )
			    {
				case DACMD_WRITE_CONF_ONDISK:
				case DACMD_WRITE_CONFIG:
				case DACMD_WRITE_CONF2:
				case DACMD_WRITE_CONFLABEL:
				case DACMD_WRITE_CONFIG_V3x:
				case DACMD_ADD_CONFIG_V2x:
				case DACMD_ADD_CONFIG_V3x:
				case DACMD_STORE_IMAGE:
				case DACMD_ADD_CAPACITY:
				case DACMD_WRITE_IOPORT:
				case DACMD_S2S_WRITEFULLCONF:
				case DACMD_S2S_ADDFULLCONF:
				case DACMD_S2S_WRITELUNMAP_OLD:
				case DACMD_S2S_WRITELUNMAP:
				case DACMD_S2S_WRITE_IOPORT:
				case DACMD_WRITE_V3x:
				case DACMD_S2S_WRITESIG:
					pkt->control_flags |= BIT_6;
					break;
				default:
					pkt->control_flags |= BIT_5;
			    }
			}
			else
			{
                       		pkt->control_flags |= BIT_5;
			}

    }
