/*
 * linux/include/asm-alpha/bigmem.h
 *
 * On alpha we can address all the VM with a flat mapping. We need
 * to differentiate BIGMEM memory only because the default PCI DMA window
 * is currently limited to 2g. Thus kmap/kunmap are noops here.
 *
 * With bigmem support the alpha now is capable of allocating up to
 * 2048Giga of memory.
 *
 * Copyright (C) 2000 Andrea Arcangeli <andrea@suse.de>, SuSE GmbH
 */

#ifndef _ASM_BIGMEM_H
#define _ASM_BIGMEM_H

#include <linux/init.h>

#undef BIGMEM_DEBUG /* undef for production */

/* declarations for bigmem.c */
extern unsigned long bigmem_start, bigmem_end;

#define kmap(kaddr, type) kaddr
#define kunmap(vaddr, type) do { } while (0)

#endif /* _ASM_BIGMEM_H */
